from flask import Flask, flash, render_template, request, redirect, url_for, send_file
from flask_socketio import SocketIO, emit, join_room
from file_upload import save_file

from celery import Celery
#app = Flask(__name__)
app = Flask(__name__, static_folder='form-react/build', static_url_path='/')
app.config.from_object("config")
app.secret_key = app.config['SECRET_KEY']
socket = SocketIO(app)
def make_celery(app):
    celery = Celery(
        app.import_name,
        broker=app.config['CELERY_BROKER_URL']
    )
    celery.conf.update(app.config)

    class ContextTask(celery.Task):
        def __call__(self, *args, **kwargs):
            with app.app_context():
                return self.run(*args, **kwargs)

    celery.Task = ContextTask
    return celery

celery = make_celery(app)

@app.route('/')
def index():
    return app.send_static_file('index.html')

@socket.on('connect')
def on_connect():
    print('socket user connected')

@socket.on('join_room')
def on_room(json):

    room = str(session['uid'])
    referrer = json['referrer']
    join_room(room)
    print('\t\t\t|-----Room ID: ' + room)
    print('\t\t\t|-----Referrer: ' + referrer)


#@app.route('/upload', methods=['POST'])
#def upload():
    #if request.method == 'GET':
    #    return render_template('index.html')
    #elif 
        #request.method == 'POST':
 

@socket.on('request account')
def request_account(json, methods=['GET', 'POST']):
        data = {}
        data['first_name'] = request.form['first_name']
        data['last_name'] = request.form['last_name']
        data['message'] = request.form['message']
       
        print(data['firstname']) 
        print(data['message']) 
        #return redirect(url_for('index'))
        return data

# Download API
@app.route("/downloadfile/<filename>", methods = ['GET'])
def download_file(filename):
    return render_template('download.html',value=filename)

@app.route('/return-files/<filename>')
def return_files_tut(filename):
    file_path = app.config['DOWNLOAD_FOLDER'] + "/" + filename
    return send_file(file_path, as_attachment=True, attachment_filename='')

if __name__ == '__main__':
    app.run(debug=True, host='0.0.0.0')
